Player = {}
Player.__index = Player 

function Player.new(x, y)
    local instance = setmetatable({}, Player)
    instance.x = x
    instance.y = y
    instance.a = math.rad(90)
    instance.delX = math.cos(instance.a)*5
    instance.delY = math.sin(instance.a)*5
    return instance
end

function Player:move(dt)
    --moving forward and backwards 
    if love.keyboard.isScancodeDown("w") then 
        self.x = self.x + self.delX * dt * 20
        self.y = self.y + self.delY * dt * 20
    end 
    if love.keyboard.isScancodeDown("s") then 
        self.x = self.x - self.delX * dt  * 20
        self.y = self.y - self.delY * dt  * 20
    end 
    --rotation
    if love.keyboard.isScancodeDown("a") then 
        self.a = self.a - 5 * dt
        if self.a < 0 then 
            self.a = self.a + math.pi*2 
        end 
        self.delX = math.cos(self.a) * 5
        self.delY = math.sin(self.a) * 5
    end
    if love.keyboard.isScancodeDown("d") then 
        self.a = self.a + 5 * dt
        if self.a > math.pi*2 then 
            self.a = 0
        end 
        self.delX = math.cos(self.a) * 5 
        self.delY = math.sin(self.a) * 5
    end 
end

function Player:draw()
    love.graphics.setColor(1, 1, 0)
    love.graphics.circle("fill", self.x, self.y, 5)
    love.graphics.line(self.x, self.y, self.x + self.delX*5, self.y + self.delY * 5)
    love.graphics.setColor(1, 1, 1)
end