require "actors/player"

function love.load()
    screen_width = love.graphics.getWidth()
    screen_height = love.graphics.getHeight()
    P = Player.new(16*16, 16*16)
    map_width = 16
    map_height = 16
    tile_size = 32
    wall_height = 10000
    fov = math.pi / 2
    screen = {}
    map = {
        {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 1, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1, },
        {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, }}
    --hits = {}
end

function love.update(dt)
    P:move(dt)
end

function love.draw()

    for y, xs in ipairs(map) do 
        for x, value in ipairs(xs) do 
            if value == 1 then 
                love.graphics.rectangle("fill", (x-1)*tile_size, (y-1)*tile_size, tile_size, tile_size)
            end
        end
    end

    P:draw()
    RayCast(0.1,screen_width / 2)

    --for i, h in ipairs(hits) do
    --    love.graphics.setColor(0, 1, 0)
    --    love.graphics.circle("fill", h.x, h.y, 3, 3)
    --    love.graphics.setColor(1, 1, 1)
    --end

    love.graphics.setColor(0, 0, 0)
    love.graphics.print(love.timer.getFPS())
    love.graphics.setColor(1, 1,1)

end

function RayCast(ray_step_size, num_rays)

    num_rays = num_rays or screen_width
    ray_step_size = ray_step_size or 5

    local angle = P.a - fov / 2
    local step = fov / (num_rays - 1)

    love.graphics.setColor(1, 0, 0) -- We apply the line color only once

    for i = 1, num_rays do

        local sin_a = math.sin(angle)
        local cos_a = math.cos(angle)

        local x = P.x
        local y = P.y

        local distance_to_wall = 0
        local hit_wall = false

        while not hit_wall do

            local map_x = math.floor(x / tile_size) + 1 -- Round ray pos to map pos
            local map_y = math.floor(y / tile_size) + 1

            if map[map_y][map_x] == 1 then -- If the step of the ray is in a wall, we calculate the distance
                distance_to_wall = math.sqrt((x - P.x) ^ 2 + (y - P.y) ^ 2)
                hit_wall = true
                break
            end

            x = x + cos_a * ray_step_size   -- Next raystep
            y = y + sin_a * ray_step_size

            if x < 0 or y < 0 or x > map_width * tile_size or y > map_height * tile_size then -- Security if you leave the map
                break
            end

        end

        -- Draw the red line to the nearest wall --

        local line_end_x = P.x + cos_a * distance_to_wall
        local line_end_y = P.y + sin_a * distance_to_wall
        --love.graphics.line(P.x, P.y, line_end_x, line_end_y)
        
        --draw 3d space 
        local h = wall_height / distance_to_wall --height of the walls
        love.graphics.setColor(1, 1, 1, h / 500)
        love.graphics.line(screen_width /2 + i, screen_height / 2 - h / 2,screen_width /2 + i , screen_height / 2 + h /2  )
        


        -- We go to the next angle step (next ray) --

        angle = angle + step

    end

end
